]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
Corrected guardian
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.1" # Version number
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36IPFVER="full" # Which versions should be compiled? (full|devel)
37
38# Set an information about the build number
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53fi
54
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
62
63# Include funtions
64. tools/make-functions
65
66if [ -f .config ]; then
67 . .config
68else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76fi
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315}
316
317buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake backup
322 ipfiremake dhcp
323 ipfiremake dhcpcd
324 ipfiremake libusb
325 ipfiremake libpcap
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake zaptel SMP=1
332 ipfiremake linux
333 ipfiremake ipp2p
334 ipfiremake zaptel
335 ipfiremake pkg-config
336 ipfiremake linux-atm
337 ipfiremake cpio
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
344 ipfiremake pam
345 ipfiremake openssl
346 ipfiremake curl
347 ipfiremake python
348 ipfiremake libnet
349 ipfiremake libidn
350 ipfiremake libjpeg
351 ipfiremake libpng
352 ipfiremake libtiff
353 ipfiremake libart
354 ipfiremake freetype
355 ipfiremake gd
356 ipfiremake popt
357 ipfiremake pcre
358 ipfiremake slang
359 ipfiremake newt
360 ipfiremake libcap
361 ipfiremake pciutils
362 ipfiremake usbutils
363 ipfiremake libxml2
364 ipfiremake libxslt
365 ipfiremake BerkeleyDB
366 ipfiremake mysql
367 ipfiremake cyrus-sasl
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
371 ipfiremake apache2 PASS=C
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
378 ipfiremake squashfstools
379 ipfiremake reiserfsprogs
380 ipfiremake xfsprogs
381 ipfiremake sysfsutils
382 ipfiremake fuse
383 ipfiremake ntfs-3g
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
387 ipfiremake perl-GD
388 ipfiremake GD-Graph
389 ipfiremake GD-TextUtil
390 ipfiremake gnupg
391 ipfiremake hdparm
392 ipfiremake sdparm
393 ipfiremake mtools
394 ipfiremake initscripts
395 ipfiremake whatmask
396 ipfiremake iptables
397 ipfiremake libupnp
398 ipfiremake ipp2p IPT=1
399 ipfiremake linux-igd
400 ipfiremake ipac-ng
401 ipfiremake ipaddr
402 ipfiremake iptstate
403 ipfiremake iputils
404 ipfiremake l7-protocols
405 ipfiremake mISDN
406 ipfiremake hwdata
407 ipfiremake kudzu
408 ipfiremake logrotate
409 ipfiremake logwatch
410 ipfiremake misc-progs
411 ipfiremake nano
412 ipfiremake nasm
413 ipfiremake URI
414 ipfiremake HTML-Tagset
415 ipfiremake HTML-Parser
416 ipfiremake Compress-Zlib
417 ipfiremake Digest
418 ipfiremake Digest-SHA1
419 ipfiremake Digest-HMAC
420 ipfiremake libwww-perl
421 ipfiremake Net-DNS
422 ipfiremake Net-IPv4Addr
423 ipfiremake Net_SSLeay
424 ipfiremake IO-Stringy
425 ipfiremake Unix-Syslog
426 ipfiremake Mail-Tools
427 ipfiremake MIME-Tools
428 ipfiremake Net-Server
429 ipfiremake Convert-TNEF
430 ipfiremake Convert-UUlib
431 ipfiremake Archive-Tar
432 ipfiremake Archive-Zip
433 ipfiremake Text-Tabs+Wrap
434 ipfiremake Locale-Country
435 ipfiremake XML-Parser
436 ipfiremake glib
437 ipfiremake GeoIP
438 ipfiremake fwhits
439 ipfiremake noip_updater
440 ipfiremake ntp
441 ipfiremake openssh
442 ipfiremake openswan
443 ipfiremake rrdtool
444 ipfiremake setserial
445 ipfiremake setup
446 ipfiremake snort
447 ipfiremake oinkmaster
448 ipfiremake squid
449 ipfiremake squid-graph
450 ipfiremake squidguard
451 ipfiremake calamaris
452 ipfiremake tcpdump
453 ipfiremake traceroute
454 ipfiremake vlan
455 ipfiremake wireless
456 ipfiremake libsafe
457 ipfiremake pakfire
458 ipfiremake java
459 ipfiremake spandsp
460 ipfiremake lzo
461 ipfiremake openvpn
462 ipfiremake pammysql
463 ipfiremake cups
464 ipfiremake ghostscript
465 ipfiremake foomatic
466 ipfiremake hplip
467 ipfiremake samba
468 ipfiremake sudo
469 ipfiremake mc
470 ipfiremake wget
471 ipfiremake bridge-utils
472 ipfiremake screen
473 ipfiremake hddtemp
474 ipfiremake smartmontools
475 ipfiremake htop
476 ipfiremake postfix
477 ipfiremake fetchmail
478 ipfiremake cyrus-imapd
479 ipfiremake openmailadmin
480 ipfiremake clamav
481 ipfiremake spamassassin
482 ipfiremake amavisd
483 ipfiremake alsa
484 ipfiremake mpg123
485 ipfiremake mpfire
486 ipfiremake guardian
487 ipfiremake libid3tag
488 ipfiremake libmad
489 ipfiremake libogg
490 ipfiremake libvorbis
491 ipfiremake lame
492 ipfiremake sox
493 ipfiremake libshout
494 ipfiremake icecast
495 ipfiremake icegenerator
496 ipfiremake mpd
497 ipfiremake mpc
498 ipfiremake xvid
499 ipfiremake libmpeg2
500 ipfiremake videolan
501 ipfiremake libpri
502 ipfiremake asterisk
503 ipfiremake gnump3d
504 ipfiremake libsigc++
505 ipfiremake applejuice
506 ipfiremake ocaml
507 ipfiremake mldonkey
508 ipfiremake libtorrent
509 ipfiremake rtorrent
510 ipfiremake ipfireseeder
511 ipfiremake rsync
512 ipfiremake tcpwrapper
513 ipfiremake portmap
514 ipfiremake nfs
515 ipfiremake nmap
516 ipfiremake mbmon
517 ipfiremake ncftp
518 ipfiremake etherwake
519 ipfiremake bwm-ng
520 ipfiremake tripwire
521 ipfiremake sysstat
522 ipfiremake vsftpd
523 ipfiremake which
524 ipfiremake lsof
525 ipfiremake centerim
526 ipfiremake br2684ctl
527 ipfiremake collectd
528 ipfiremake lcd4linux
529 ipfiremake neon
530 ipfiremake subversion
531}
532
533buildinstaller() {
534 # Run installer scripts one by one
535 LOGFILE="$BASEDIR/log/_build.installer.log"
536 export LOGFILE
537 ipfiremake syslinux
538 ipfiremake as86
539 ipfiremake mbr
540 ipfiremake memtest
541 installmake linux-libc-header
542 installmake binutils
543 ipfiremake uClibc PASS=1
544 ipfiremake gcc INST=1
545 installmake uClibc PASS=2
546 installmake gcc INST=2
547 installmake uClibc PASS=3
548 installmake busybox
549 installmake udev
550 installmake slang
551 installmake newt
552 installmake gettext
553 installmake kbd
554 installmake popt
555 installmake sysvinit
556 installmake misc-progs
557 installmake libaal
558 installmake reiser4progs
559 installmake reiserfsprogs
560 installmake sysfsutils
561 installmake util-linux
562 installmake pciutils
563 installmake zlib
564 installmake mtd
565 installmake wget
566 installmake hwdata
567 installmake kudzu
568 installmake installer
569 installmake initrd
570}
571
572buildpackages() {
573 LOGFILE="$BASEDIR/log/_build.packages.log"
574 export LOGFILE
575 echo "... see detailed log in _build.*.log files" >> $LOGFILE
576
577 installmake strip
578
579 # Generating list of packages used
580 echo -n "Generating packages list from logs" | tee -a $LOGFILE
581 rm -f $BASEDIR/doc/packages-list
582 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
583 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
584 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
585 fi
586 done
587 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
588 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
589 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
590 rm -f $BASEDIR/doc/packages-list
591 # packages-list.txt is ready to be displayed for wiki page
592 beautify message DONE
593
594 # Create images for install
595 ipfiremake cdrom ED=full
596
597 # Check if there is a loop device for building in virtual environments
598 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
599 ipfiremake usb-stick
600 fi
601 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
602
603 ipfirepackages
604
605 # Cleanup
606 stdumount
607 rm -rf $BASEDIR/build/tmp/*
608
609 # Generating total list of files
610 echo -n "Generating files list from logs" | tee -a $LOGFILE
611 rm -f $BASEDIR/log/FILES
612 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
613 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
614 echo "##" >>$BASEDIR/log/FILES
615 echo "## `basename $i`" >>$BASEDIR/log/FILES
616 echo "##" >>$BASEDIR/log/FILES
617 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
618 fi
619 done
620 beautify message DONE
621
622 cd $PWD
623}
624
625ipfirepackages() {
626 ipfiremake core-updates
627 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
628 if [ -e $BASEDIR/lfs/$i ]; then
629 ipfiredist $i
630 else
631 echo -n $i
632 beautify message SKIP
633 fi
634 done
635 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
636 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
637 rm -rf $BASEDIR/build/install/packages/*
638}
639
640# See what we're supposed to do
641case "$1" in
642build)
643 clear
644 BUILDMACHINE=`uname -m`
645 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
646 #only restore on a clean disk
647 if [ ! -f log/cleanup-toolchain-2-tools ]; then
648 if [ ! -n "$PACKAGE" ]; then
649 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
650 prepareenv
651 buildtoolchain
652 else
653 PACKAGENAME=${PACKAGE%.tar.gz}
654 beautify build_stage "Packaged toolchain compilation"
655 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
656 tar zxf $PACKAGE
657 prepareenv
658 else
659 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
660 fi
661 fi
662 else
663 echo -n "Using installed toolchain" | tee -a $LOGFILE
664 beautify message SKIP
665 prepareenv
666 fi
667
668 beautify build_start
669 beautify build_stage "Building LFS"
670 buildbase
671
672 beautify build_stage "Building IPFire"
673 buildipfire
674
675 # Setzen des IPFire Builds
676 if [ "$FIREBUILD" ]; then
677 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
678 else
679 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
680 fi
681
682 beautify build_stage "Building installer"
683 buildinstaller
684
685 beautify build_stage "Building packages"
686 buildpackages
687 beautify build_end
688 ;;
689shell)
690 # enter a shell inside LFS chroot
691 # may be used to changed kernel settings
692 prepareenv
693 entershell
694 ;;
695changelog)
696 echo -n "Loading new Changelog from SVN: "
697 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
698 beautify message DONE
699 ;;
700clean)
701 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
702 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
703 $LOSETUP -d $i 2>/dev/null
704 done
705 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
706 umount $i
707 done
708 stdumount
709 for i in `seq 0 7`; do
710 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
711 umount /dev/loop${i} 2>/dev/null;
712 losetup -d /dev/loop${i} 2>/dev/null;
713 fi;
714 done
715 rm -rf $BASEDIR/build
716 rm -rf $BASEDIR/cdrom
717 rm -rf $BASEDIR/packages
718 rm -rf $BASEDIR/log
719 if [ -h /tools ]; then
720 rm -f /tools
721 fi
722 beautify message DONE
723 ;;
724downloadsrc)
725 if [ ! -d $BASEDIR/cache ]; then
726 mkdir $BASEDIR/cache
727 fi
728 mkdir -p $BASEDIR/log
729 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
730 FINISHED=0
731 cd $BASEDIR/lfs
732 for c in `seq $MAX_RETRIES`; do
733 if (( FINISHED==1 )); then
734 break
735 fi
736 FINISHED=1
737 cd $BASEDIR/lfs
738 for i in *; do
739 if [ -f "$i" -a "$i" != "Config" ]; then
740 echo -ne "Loading $i"
741 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
742 if [ $? -ne 0 ]; then
743 beautify message FAIL
744 FINISHED=0
745 else
746 if [ $c -eq 1 ]; then
747 beautify message DONE
748 fi
749 fi
750 fi
751 done
752 done
753 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
754 ERROR=0
755 for i in *; do
756 if [ -f "$i" -a "$i" != "Config" ]; then
757 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
758 if [ $? -ne 0 ]; then
759 echo -ne "MD5 difference in lfs/$i"
760 beautify message FAIL
761 ERROR=1
762 fi
763 fi
764 done
765 if [ $ERROR -eq 0 ]; then
766 echo -ne "${BOLD}all files md5sum match${NORMAL}"
767 beautify message DONE
768 else
769 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
770 beautify message FAIL
771 fi
772 cd - >/dev/null 2>&1
773 ;;
774toolchain)
775 clear
776 prepareenv
777 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
778 buildtoolchain
779 BUILDMACHINE=`uname -m`
780 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
781 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
782 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
783 build/{bin,etc,usr/bin,usr/local} \
784 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
785 log >> $LOGFILE
786 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
787 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
788 stdumount
789 ;;
790gettoolchain)
791 BUILDMACHINE=`uname -m`
792 # arbitrary name to be updated in case of new toolchain package upload
793 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
794 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
795 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
796 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
797 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
798 cd $BASEDIR/cache/toolchains
799 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
800 if [ $? -ne 0 ]; then
801 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
802 else
803 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
804 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
805 else
806 exiterror "$PACKAGE.md5 did not match, check downloaded package"
807 fi
808 fi
809 else
810 echo "Toolchain is already downloaded. Exiting..."
811 fi
812 ;;
813othersrc)
814 prepareenv
815 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
816 chroot $LFS /tools/bin/env -i HOME=/root \
817 TERM=$TERM PS1='\u:\w\$ ' \
818 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
819 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
820 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
821 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
822 if [ $? -eq "0" ]; then
823 beautify message DONE
824 else
825 beautify message FAIL
826 fi
827 stdumount
828 ;;
829svn)
830 case "$2" in
831 update|up)
832 # clear
833 echo -ne "Loading the latest source files...\n"
834 if [ $3 ]; then
835 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
836 else
837 svn update | tee -a $PWD/log/_build.svn.update.log
838 fi
839 if [ $? -eq "0" ]; then
840 beautify message DONE
841 else
842 beautify message FAIL
843 exit 1
844 fi
845 echo -ne "Writing the svn-info to a file"
846 svn info > $PWD/svn_status
847 if [ $? -eq "0" ]; then
848 beautify message DONE
849 else
850 beautify message FAIL
851 exit 1
852 fi
853 chmod 755 $0
854 exit 0
855 ;;
856 commit|ci)
857 clear
858 if [ -f /usr/bin/mcedit ]; then
859 export EDITOR=/usr/bin/mcedit
860 fi
861 if [ -f /usr/bin/nano ]; then
862 export EDITOR=/usr/bin/nano
863 fi
864 echo -ne "Selecting editor $EDITOR..."
865 beautify message DONE
866 if [ -e /sbin/yast ]; then
867 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
868 $0 changelog
869 fi
870 fi
871 update_langs
872 svn commit
873 $0 svn up
874 if [ -n "$FTP_CACHE_URL" ]; then
875 $0 uploadsrc
876 fi
877 ;;
878 dist)
879 if [ $3 ]; then
880 SVN_REVISION=$3
881 fi
882 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
883 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
884 exit 0
885 fi
886 echo -en "REV $SVN_REVISION: Downloading..."
887 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
888 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
889 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
890 evaluate 1
891
892 echo -en "REV $SVN_REVISION: Compressing files..."
893 if [ -e ipfire-source/trunk/make.sh ]; then
894 chmod 755 ipfire-source/trunk/make.sh
895 fi
896 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
897 evaluate 1
898 echo -en "REV $SVN_REVISION: Cleaning up..."
899 rm ipfire-source/ -r
900 evaluate 1
901 ;;
902 diff|di)
903 update_langs
904 echo -ne "Make a local diff to last svn revision"
905 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
906 evaluate 1
907 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
908 svn status
909 ;;
910 esac
911 ;;
912uploadsrc)
913 PWD=`pwd`
914 cd $BASEDIR/cache/
915 echo -e "Uploading cache to ftp server:"
916 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
917 for i in *; do
918 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
919 grep -q $(basename $i) /tmp/ftplist
920 if [ "$?" -ne "0" ]; then
921 echo -ne "$(basename $i)"
922 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
923 if [ "$?" -ne "0" ]; then
924 beautify message FAIL
925 fi
926 fi
927 done
928 rm -f /tmp/ftplist
929 cd $PWD
930 exit 0
931 ;;
932upload)
933 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
934 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
935 if [ -z $FTP_ISO_PORT ]; then
936 FTP_ISO_PORT=21
937 fi
938 cat <<EOF > .ftp-commands
939mkdir -p $FTP_ISO_PATH$SVN_REVISION
940mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
941quit
942EOF
943 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
944 rm -f .ftp-commands
945
946 case "$2" in
947 iso)
948 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
949
950 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
951 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
952 if [ -e "$i" ]; then
953 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
954 if [ "$?" -eq "0" ]; then
955 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
956 else
957 echo "There was an error while uploading the file $i to the ftp server."
958 exit 1
959 fi
960 fi
961 done
962 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
963 if [ "$3" = "--with-sources-cd" ]; then
964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
965 fi
966 ;;
967 paks)
968 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
969 if [ "$?" -eq "0" ]; then
970 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
971 else
972 echo -e "There was an error while uploading the packages to the ftp server."
973 exit 1
974 fi
975 ;;
976 esac
977 ;;
978batch)
979 if [ "$2" = "--background" ]; then
980 batch_script
981 exit $?
982 fi
983 if [ `screen -ls | grep -q ipfire` ]; then
984 echo "Build is already running, sorry!"
985 exit 1
986 else
987 if [ "$2" = "--rebuild" ]; then
988 export IPFIRE_REBUILD=1
989 echo "REBUILD!"
990 else
991 export IPFIRE_REBUILD=0
992 fi
993 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
994 screen -dmS ipfire $0 batch --background
995 evaluate 1
996 exit 0
997 fi
998 ;;
999watch)
1000 watch_screen
1001 ;;
1002pxe)
1003 case "$2" in
1004 start)
1005 start_tftpd
1006 ;;
1007 stop)
1008 stop_tftpd
1009 ;;
1010 reload|restart)
1011 reload_tftpd
1012 ;;
1013 esac
1014 exit 0
1015 ;;
1016lang)
1017 update_langs
1018 ;;
1019"")
1020 clear
1021 svn info
1022 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1023 do
1024 case $name in
1025 "IPFIRE: Downloadsrc")
1026 $0 downloadsrc
1027 ;;
1028 "IPFIRE: Build (silent)")
1029 $0 build-silent
1030 ;;
1031 "IPFIRE: Watch Build")
1032 $0 watch
1033 ;;
1034 "IPFIRE: Batch")
1035 $0 batch
1036 ;;
1037 "IPFIRE: Clean")
1038 $0 clean
1039 ;;
1040 "SVN: Update")
1041 $0 svn update
1042 ;;
1043 "Help")
1044 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1045 cat doc/make.sh-usage
1046 ;;
1047 "LOG: Tail")
1048 tail -f log/_*
1049 ;;
1050 "Exit")
1051 break
1052 ;;
1053 esac
1054 done
1055 ;;
1056config)
1057 make_config
1058 ;;
1059*)
1060 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1061 cat doc/make.sh-usage
1062 ;;
1063esac